<script setup lang="ts">
////////////////////////////////
// IMPORT
////////////////////////////////

import { useNodeStore } from "@/stores/useNodeStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

////////////////////////////////
// PROPS
////////////////////////////////

const props = defineProps({
  nodeLeaveDialog: {
    type: Boolean,
    required: true,
  },
});

////////////////////////////////
// EMITS
////////////////////////////////

const emits = defineEmits(["nodeLeaveDialog", "hasLeft"]);

////////////////////////////////
// DATA
////////////////////////////////

const nodeStore = useNodeStore();
const workspaceStore = useWorkspaceStore();
const drawer = ref(false);

////////////////////////////////
// WATCH
////////////////////////////////

watch(
  () => props.nodeLeaveDialog,
  (newValue) => {
    drawer.value = newValue;
  },
);

////////////////////////////////
// METHODS
////////////////////////////////

// The `close()` function is responsible for closing the dialog box and emitting an
// event to notify the parent component that the node leave dialog should
// be closed.
function close() {
  drawer.value = false;
  emits("nodeLeaveDialog", false);
}

// The `leaveNode` function is an asynchronous function that is called
// when the user clicks on the "Leave" button in the dialog box.
async function leaveNode() {
  nodeStore.deleteMember(nodeStore.currentMember.value).then(async (res) => {
    if (res === true) {
      emits("hasLeft", true);
      nodeStore.nodes.get(nodeStore.currentNid).value.userRole = null;
      await nodeStore.fetchNodes().then(() => {
        if (nodeStore.nodeMap.size === 0) {
          navigateTo(`/${workspaceStore.currentWSlug}`);
        } else {
          navigateTo(
            `/${
              workspaceStore.currentWSlug
            }/${
              Array.from(nodeStore.nodeMap.values())[0].value.id}`,
          );
        }
      });
    }
    close();
  });
}
</script>

<template>
  <v-dialog
    v-model="drawer"
    width="auto"
    persistent
  >
    <v-card>
      <v-card-title><v-icon>mdi-exit-to-app</v-icon> Leaving the node</v-card-title>
      <v-card-text> You are about to leave the node. Are you sure? </v-card-text>
      <v-card-actions class="d-flex flex-row-reverse">
        <v-btn color="error" @click="leaveNode()">
          Leave
        </v-btn>
        <v-btn @click="close()">
          Cancel
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
